<template>
  <el-row :gutter="20" align="middle" class="personPage">
    <el-col class="headBlock">
      <router-link class="prev-link" :to="{name: 'PersonAllPage'}"><img src="@/assets/arrow-left.svg" class="icon-image" alt=""> Назад</router-link>
      <h1>{{ forEdit?'Редактировать персону':'Создать персону' }}</h1>
    </el-col>
    <template v-if="this.dictionaries !== '' && this.personForm !== ''">
      <el-form :rules="this.options.rules" :model="this.personForm" ref="personForm" style="width: 100%;margin-top: 20px" v-loading="loading" class="personModal">
      <el-row :gutter="20">

        <el-col>
          <div class="defaultBlock">
            <p class="title">Персона</p>
            <el-row :gutter="20">
              <el-col :span="12">
                <el-form-item label="Тип лица" prop="">
                  <el-select v-model="personForm.type_id" placeholder="Тип лица">
                    <el-option
                        v-for="item in dictionaries.person_type"
                        :key="item.id"
                        :label="item.name"
                        :value="item.id"
                    />
                  </el-select>
                </el-form-item>
              </el-col>
              <el-col :span="12">
                <el-form-item label="Роль Персоны" prop="">
                  <el-select v-model="personForm.role_ids[0].role_id" placeholder="Роль Персоны">
                    <el-option
                        v-for="item in dictionaries.role"
                        :key="item.id"
                        :label="item.name"
                        :value="item.id"
                    />
                  </el-select>
                </el-form-item>
              </el-col>

              <el-col v-if="personForm.type_id === 1">
                <PeopleInfoFields/>
              </el-col>

              <el-col v-if="personForm.type_id === 2">
                <IpInfoFields/>
              </el-col>

              <el-col v-if="personForm.type_id === 3">
                <CompanyInfoFields/>
              </el-col>
            </el-row>
          </div>
        </el-col>

        <el-col>
          <div class="defaultBlock">
            <p class="title">Информация о документе</p>
            <el-row :gutter="20">
              <el-col>
                <DocumentFields/>
              </el-col>
            </el-row>
          </div>
        </el-col>

        <el-col>
          <div class="defaultBlock">
            <p class="title">Перечень контактов</p>
            <el-row :gutter="20">
              <el-col>
                <ContactsFields/>
              </el-col>
            </el-row>
          </div>
        </el-col>

        <el-col>
          <div class="defaultBlock">
            <p class="title">Риски</p>
            <el-row :gutter="20">
              <el-col>
                <RisksFields/>
              </el-col>
            </el-row>
          </div>
        </el-col>

        <el-col>
          <div class="defaultBlock">
            <p class="title">Лицензии</p>
            <el-row :gutter="20">
              <el-col>
                <LicensesFields/>
              </el-col>
            </el-row>
          </div>
        </el-col>

        <el-col>
          <div class="defaultBlock">
            <p class="title">Информация о налогооблажении</p>
            <el-row :gutter="20">
              <el-col>
                <NalogFields/>
              </el-col>
            </el-row>
          </div>
        </el-col>

        <el-col>
          <div class="defaultBlock">
            <p class="title">Доступы к биржам</p>
            <el-row :gutter="20">
              <el-col>
                <BirzhesFields/>
              </el-col>
            </el-row>
          </div>
        </el-col>

        <el-col class="personFormButtons">
          <template v-if="this.forEdit">
            <el-button type="primary" @click="editPerson">Сохранить изменения <img src="@/assets/person-form/save.svg" class="icon-image" alt=""></el-button>
          </template>
          <template v-else>
            <el-button type="primary" @click="addPerson">Добавить персону <img src="@/assets/person-form/add.svg" class="icon-image" alt=""></el-button>
          </template>
          <el-button type="info" @click="this.$router.push({name: 'PersonAllPage'})">Отменить <img src="@/assets/person-form/cancel.svg" class="icon-image" alt=""></el-button>
          <template v-if="this.forEdit">
            <el-popconfirm
                width="220"
                confirm-button-text="Удалить"
                cancel-button-text="Нет, спасибо"
                icon-color="#626AEF"
                title="Вы точно хотите удалить персону?"
                @confirm="deletePerson">
              <template #reference>
                <el-button type="info">Удалить <img src="@/assets/person-form/delete.svg" class="icon-image" alt=""></el-button>
              </template>
            </el-popconfirm>
          </template>
        </el-col>

      </el-row>
    </el-form>
    </template>
  </el-row>
</template>

<script>
import {
  GET_DICTIONARIES,
  ADD_PERSON,
  PERSON_FORM_DEFAULT,
  GET_PERSON_BY_ID_FOR_EDIT,
  EDIT_PERSON,
  DELETE_PERSON
} from "@/store/modules/PersonModule";
import PeopleInfoFields from "@/views/cabinet-components/person-form/PeopleInfoFields";
import IpInfoFields from "@/views/cabinet-components/person-form/IpInfoFields";
import CompanyInfoFields from "@/views/cabinet-components/person-form/CompanyInfoFields";
import DocumentFields from "@/views/cabinet-components/person-form/DocumentFields";
import ContactsFields from "@/views/cabinet-components/person-form/ContactsFields";
import RisksFields from "@/views/cabinet-components/person-form/RisksFields";
import LicensesFields from "@/views/cabinet-components/person-form/LicensesFields";
import NalogFields from "@/views/cabinet-components/person-form/NalogFields";
import BirzhesFields from "@/views/cabinet-components/person-form/BirzhesFields";
export default {
  components:{
    PeopleInfoFields,
    IpInfoFields,
    CompanyInfoFields,
    DocumentFields,
    ContactsFields,
    RisksFields,
    LicensesFields,
    NalogFields,
    BirzhesFields,
  },
  data:()=>({
    loading: true,
    forEdit: false
  }),
  methods:{
    async getDictionaries(){
      try {
        await this.$store.dispatch(GET_DICTIONARIES);
        this.defaultPersonForm();
      } catch (e) {
        this.$message.error(e.response.data.error);
      }
    },
    async addPerson(){
      try {
        this.loading = true;
        await this.$store.dispatch(ADD_PERSON);
        this.$router.push({name: 'PersonAllPage'});
        this.$message.success('Персона успешно добавлена!');
        this.loading = false;
      } catch (e) {
        this.$message.error(e.response.data.error);
        this.loading = false;
      }
    },
    async editPerson(){
      try {
        this.loading = true;
        await this.$store.dispatch(EDIT_PERSON);
        this.$router.push({name: 'PersonAllPage'});
        this.$message.success('Изменения внесены!');
        this.loading = false;
      } catch (e) {
        this.$message.error(e.response.data.error);
        this.loading = false;
      }
    },
    async deletePerson(){
      try {
        this.loading = true;
        await this.$store.dispatch(DELETE_PERSON, this.$route.params.id);
        this.$router.push({name: 'PersonAllPage'});
        this.$message.success('Персона успешно удалена!');
        this.loading = false;
      } catch (e) {
        this.$message.error(e.response.data.error);
        this.loading = false;
      }
    },
    async defaultPersonForm(){
      try {
        await this.$store.commit(PERSON_FORM_DEFAULT);
        if(this.$route.meta.pageType === 'edit'){
          this.getPersonById(this.$route.params.id);
        }else{
          this.loading = false;
        }
      } catch (e) {
        this.$message.error(e.response.data.error);
      }
    },
    async getPersonById(person_id){
      try {
        await this.$store.dispatch(GET_PERSON_BY_ID_FOR_EDIT, person_id);
        this.loading = false;
      } catch (e) {
        this.$message.error(e.response.data.error);
      }
    }
  },
  created(){
    if(this.$route.meta.pageType === 'edit'){
      this.forEdit = true;
    }
    this.getDictionaries();
  },
  computed:{
    personForm() {
      return this.$store.getters.get_person_form;
    },
    dictionaries() {
      return this.$store.getters.get_dictionaries;
    },
    options() {
      return this.$store.getters.get_options;
    }
  }
}
</script>